% PART 1: Experimentation

function [outliers, distance_avg] = experiment(neurons,steps,learningrate,radius)

    outliers = 0;
    data = nicering;

    som = lab_som(data,neurons,steps,learningrate,radius);

    for neuron=1:size(som,1)
        distance(neuron) = minDistance(som(neuron,:),data);
        if distance(neuron) > 0.03
            outliers = outliers + 1;
        end
        %disp(['Neuron n.' num2str(neuron) ': ' num2str(distance(neuron))]);
    end
    
    distance_avg = mean(distance);
    
    %disp(['Average distance: ' num2str(mean(distance))]);
    %disp(['Outliers (>0.03): ' num2str(outliers)]);
    
end

% Find the winner neuron
function winner = minDistance (xn,data)
    for i=1:size(data,1)
        dist(i) = norm(xn-data(i,:),2);
    end
    dist = sort(dist);
    winner = dist(1);
end