% GRID SEARCH FOR SELF-ORGANIZING MAP
% Michele Filannino
% The University of Manchester

clear all;

neurons = [16];%[4 8 16 64 256 512];
iterations = [10000];%[50 100 1000 5000 10000];
learningRate = [0.01 0.1 1 10 100];
radius = [0.01 0.1 0.5 1 10 100 1000];

tic;

for n=1:size(neurons,2)
    for i=1:size(iterations,2)
        for l=1:size(learningRate,2)
            for r=1:size(radius,2)
                [outliers distance_avg] = experiment(neurons(n),iterations(i),learningRate(l),radius(r));
                grid_distance(l,r) = distance_avg;
                grid_outliers(l,r) = outliers;
                disp(['(' num2str(neurons(n)) ',' num2str(iterations(i)) ',' num2str(learningRate(l)) ',' num2str(radius(r)) '): Outliers: ' num2str(outliers) '; Distance: ' num2str(distance_avg) ';']);
            end
        end
    end
end

toc;

subplot(1,2,1); title('Distance on average'); surf(grid_distance); Zlabel('Euclidean distance'); ZLim([0 1]);
subplot(1,2,2); title('Outliers'); surf(grid_outliers); Zlabel('# outliers');

clear n neurons i iterations l learningRate r radius distance_avg outliers;